<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container-fluid jumbotron">
        <div class="row d-flex align-items-center min-vh-100 p-5">
            <div class="col-md-12 mx-auto my-0 jumbotron bg-white p-5 px-5 signup-form">
                <div class="form-group">
                    <h2>User information</h3>
                </div>
                <hr>
                <div class="row">
                    <div class="col-sm-6">
                        <div class="form-group">
                            <label>First name</label>
                            <input type="text" class="form-control" id="inp-firstname" placeholder="First name">
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="form-group">
                            <label>Last name</label>
                            <input type="text" class="form-control" id="inp-lastname" placeholder="Last name">
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <label>Email</label>
                    <input type="email" class="form-control" id="inp-email" placeholder="Email">
                </div>
                <div class="form-group">
                    <button id="btn-log-out" class="btn btn-danger">Logout</button>
                </div>
            </div>
        </div>
    </div>
    <!-- Modal show message-->
    <div class="modal fade" id="modal-message">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Thong bao</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h6 id="message"></h6>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" data-dismiss="modal">
                Close
              </button>
              <button type="button" id="btn-confirm-log-out" class="btn btn-danger">Logout</button>
            </div>
          </div>
        </div>
      </div>
</body>
<script>
    //Vùng 1: định nghĩa global variable (biến toàn cục)
    const gToken = getCookie("token");
    console.log("Token là: ");
    console.log(gToken);
    callAjaxApiGetUserInfo()

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */    
    $("#btn-log-out").on("click", function() { //Set sự kiện cho nút logout
        showModalMessage("Ban co chac chan dang xuat?");
    });
    $("#btn-confirm-log-out").on("click", function() { //Set sự kiện cho nút xác nhận logout
        redirectToLogin();
    });
    

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function getCookie(cname) {
        var name = cname + "=";
        var decodedCookie = decodeURIComponent(document.cookie);
        var ca = decodedCookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') {
                c = c.substring(1);
            }
            if (c.indexOf(name) == 0) {
                return c.substring(name.length, c.length);
            }
        }
        return "";
    }
    function callAjaxApiGetUserInfo() {
        //Khai báo xác thực ở headers
        var vHeaders = {
            Authorization: "Bearer " + gToken
        };
        var urlInfo = "http://42.115.221.44:8080/devcamp-auth/users/me";
        $.ajax({
            url: urlInfo,
            method: "GET",
            headers: vHeaders,
            success: function(responseObject) {
                console.log(responseObject);
                displayUser(responseObject);
            },
            error: function(xhr) {
                console.log(xhr);
                alert("Chua login. An OK de tro ve trang login");
                // Khi token hết hạn, AJAX sẽ trả về lỗi khi đó sẽ redirect về trang login để người dùng đăng nhập lại
                redirectToLogin()
            }
        });
    }

    function redirectToLogin() {
        // Trước khi logout cần xóa token đã lưu trong cookie
        setCookie("token", "", 1);
        window.location.href = "signin.html";
    }
    //Hiển thị thông tin người dùng
    function displayUser(paramUserData) {
        $("#inp-firstname").val(paramUserData.firstname);
        $("#inp-lastname").val(paramUserData.lastname);
        $("#inp-email").val(paramUserData.email);
    };  
    function showModalMessage(paramMessage) {
        "use strict";
        $("#message").html(paramMessage);
        $("#modal-message").modal("show");
    }
    function setCookie(cname, cvalue, exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays*24*60*60*1000));
        var expires = "expires="+ d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }
</script>
</html>